/*******************************************************************************
 *	@file			Sock.cpp
 *	@brief			Network Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			10-Jan-2012(Tue)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "Sock.h"


/*******************************************************************************
 *	@namespace	NET
 ******************************************************************************/
namespace	NET
{

// O[oϐ-----------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				CSock::StreamThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			TCP/IPMpXbh
 ******************************************************************************/
unsigned __stdcall CSock::StreamThread( void *p )
{
	CSock *pTCP = reinterpret_cast<CSock*>( p );
	int nRes = -1;
	SOCKET &wsaSock = pTCP->m_pSock;

	DWORD dwBytes = 0, dwFlags = 0;
	int nRecvCnt = 0;
	char *cBuf = new CHAR[ pTCP->m_nBufSize ];

	// Mobt@
	WSABUF wsaBuf;
	wsaBuf.buf = NULL;
	wsaBuf.len = pTCP->m_nBufSize;

	// MCxg
	WSAOVERLAPPED wsaOver;
	WSANETWORKEVENTS wsaEvents;

	// Cxg쐬
	// ʒme
	// @FD_ACCEPTȂCNCAgڑv͂Ă邱Ƃʒm܂B
	// AFD_CONNECTȂC\Pbgւ̐ڑƂʒm܂B
	// BFD_WRITÉC\Pbg̑Mobt@ɋ󂫂łƂʒm܂B
	// CFD_READ́C\Pbg̎Mobt@Ƀf[^邱Ƃʒm܂B
	// DFD_CLOSÉC\Pbgւ̐ڑIƂʒm܂B
	wsaOver.hEvent = ::WSACreateEvent();
	if( wsaOver.hEvent == NULL )
		goto ERROR_THREAD;

	// łɐڑĂԂȂ̂Ň@ƇA͊܂܂Ȃ
	if( ::WSAEventSelect( wsaSock, wsaOver.hEvent, FD_READ | FD_WRITE | FD_CLOSE ) != 0 )
		goto ERROR_THREAD;

	::sprintf_s( cBuf, pTCP->m_nBufSize, "NET::SOCK %s:%d TCP/IP MJn", pTCP->m_sAddr.c_str(), pTCP->m_nPort );
	pTCP->m_pLog->SetLog( cBuf );

	// M[v
	while( 1 )
	{
		dwBytes = 0;
		nRes = ::WSAWaitForMultipleEvents( 1, &wsaOver.hEvent, FALSE, TIMEWAIT_TCP, FALSE );
		if( nRes == WSA_WAIT_FAILED )
			::shutdown( wsaSock, SD_SEND );

		::WSAEnumNetworkEvents( wsaSock, wsaOver.hEvent, &wsaEvents );

		// ؒf
		if( !pTCP->m_bConnect )
		{
			::shutdown( wsaSock, SD_SEND );
			break;
		}

		// f[^̑M
		{
			if( pTCP->m_nSendRead < pTCP->m_nSendWrite )
			{
				int nRead = pTCP->m_nSendRead % pTCP->m_nBufAry;

				// Mf[^o^
				wsaBuf.buf = reinterpret_cast<CHAR*>( pTCP->m_bySend[ nRead ] );

				nRes = ::WSASend( wsaSock, &wsaBuf, 1, &dwBytes, dwFlags, &wsaOver, NULL );
				if( nRes != SOCKET_ERROR )
				{
					::sprintf_s( cBuf, pTCP->m_nBufSize, "NET::SOCK SEND : %s", reinterpret_cast<CHAR*>( pTCP->m_bySend[ nRead ] ) );
					pTCP->m_pLog->SetLog( cBuf );

					pTCP->m_nSendRead++;

					// Oobt@p̃JE^NA
					if( ( pTCP->m_nSendRead > pTCP->m_nBufAry ) && ( pTCP->m_nSendWrite > pTCP->m_nBufAry ) )
					{
						pTCP->m_nSendRead -= pTCP->m_nBufAry;
						pTCP->m_nSendWrite -= pTCP->m_nBufAry;
					}
				}
			}
		}

		// f[^̎M
		if( wsaEvents.lNetworkEvents & FD_READ )
		{
			int nWrite = pTCP->m_nRecvWrite % pTCP->m_nBufAry;

			// Mf[^擾
			wsaBuf.buf = reinterpret_cast<CHAR*>( &pTCP->m_byRecv[ nWrite ][ nRecvCnt ] );
			::memset( wsaBuf.buf, 0, pTCP->m_nBufSize - nRecvCnt );

			nRes = ::WSARecv( wsaSock, &wsaBuf, 1, &dwBytes, &dwFlags, &wsaOver, NULL );
			if( nRes != SOCKET_ERROR )
			{
				// MTCY
				if( nRecvCnt + static_cast<int>( dwBytes ) < pTCP->m_nBufSize )
					nRecvCnt += dwBytes;
				else
				{
					::sprintf_s( cBuf, pTCP->m_nBufSize, "NET::SOCK RECV : %s", reinterpret_cast<CHAR*>( pTCP->m_byRecv[ nWrite ] ) );
					pTCP->m_pLog->SetLog( cBuf );

					nRecvCnt = 0;
					pTCP->m_nRecvWrite++;

					// Oobt@p̃JE^NA
					if( ( pTCP->m_nRecvRead > pTCP->m_nBufAry ) && ( pTCP->m_nRecvWrite > pTCP->m_nBufAry ) )
					{
						pTCP->m_nRecvRead -= pTCP->m_nBufAry;
						pTCP->m_nRecvWrite -= pTCP->m_nBufAry;
					}
				}
			}
		}

		// \Pbg̐ؒf
		if( wsaEvents.lNetworkEvents & FD_CLOSE )
			break;

		// ҋ@
		::Sleep( 1 );
		::WSAResetEvent( wsaOver.hEvent );
	}

ERROR_THREAD:
	::shutdown( wsaSock, SD_BOTH );
	if( wsaOver.hEvent != NULL )
		::WSACloseEvent( wsaOver.hEvent );
	::closesocket( wsaSock );
	wsaSock = -1;
	pTCP->m_bConnect = FALSE;

	::sprintf_s( cBuf, pTCP->m_nBufSize, "NET::SOCK %s:%d TCP/IP MI", pTCP->m_sAddr.c_str(), pTCP->m_nPort );
	pTCP->m_pLog->SetLog( cBuf );

	delete[] cBuf;

	::_endthreadex( 0 );
	return TRUE;
}
/*******************************************************************************
 *	@fn				CSock::DGramThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			UDP/IPMpXbh
 ******************************************************************************/
unsigned __stdcall CSock::DGramThread( void *p )
{
	CSock *pUDP = reinterpret_cast<CSock*>( p );
	int nRes = -1;
	SOCKET &wsaSock = pUDP->m_pSock;

	DWORD dwBytes = 0, dwFlags = 0;
	int nRecvCnt = 0;
	char *cBuf = new CHAR[ pUDP->m_nBufSize ];

	// Mobt@
	WSABUF wsaBuf;
	wsaBuf.buf = NULL;
	wsaBuf.len = pUDP->m_nBufSize;

	// MCxg
	WSAOVERLAPPED wsaOver;
	WSANETWORKEVENTS wsaEvents;

	int nAddrSize = sizeof( SOCKADDR );

	// MAhXƃ|[gݒ
	SOCKADDR_IN	sa_out;
	sa_out.sin_family			= AF_INET;
	sa_out.sin_addr.S_un.S_addr	= ::inet_addr( pUDP->m_sAddr.c_str() );
	sa_out.sin_port				= ::htons( pUDP->m_nPort );

	// Cxg쐬
	// ʒme
	// @FD_ACCEPTȂCNCAgڑv͂Ă邱Ƃʒm܂B
	// AFD_CONNECTȂC\Pbgւ̐ڑƂʒm܂B
	// BFD_WRITÉC\Pbg̑Mobt@ɋ󂫂łƂʒm܂B
	// CFD_READ́C\Pbg̎Mobt@Ƀf[^邱Ƃʒm܂B
	// DFD_CLOSÉC\Pbgւ̐ڑIƂʒm܂B
	wsaOver.hEvent = ::WSACreateEvent();
	if( wsaOver.hEvent == NULL )
		goto ERROR_THREAD;

	// UDP͓ǂݏȂ̂Ň@ƇA͊܂܂Ȃ
	if( ::WSAEventSelect( wsaSock, wsaOver.hEvent, FD_READ | FD_WRITE | FD_CLOSE ) != 0 )
		goto ERROR_THREAD;

	::sprintf_s( cBuf, pUDP->m_nBufSize, "NET::SOCK %s:%d UPD/IP MJn", pUDP->m_sAddr.c_str(), pUDP->m_nPort );
	pUDP->m_pLog->SetLog( cBuf );

	// M[v
	while( 1 )
	{
		dwBytes = 0;
		nRes = ::WSAWaitForMultipleEvents( 1, &wsaOver.hEvent, FALSE, TIMEWAIT_UDP, FALSE );
		if( nRes == WSA_WAIT_FAILED )
			::shutdown( wsaSock, SD_SEND );

		::WSAEnumNetworkEvents( wsaSock, wsaOver.hEvent, &wsaEvents );

		// ؒf
		if( !pUDP->m_bConnect )
		{
			::shutdown( wsaSock, SD_SEND );
			break;
		}

		// f[^̑M
		{
			if( pUDP->m_nSendRead < pUDP->m_nSendWrite )
			{
				int nRead = pUDP->m_nSendRead % pUDP->m_nBufAry;

				// Mf[^o^
				wsaBuf.buf = reinterpret_cast<CHAR*>( pUDP->m_bySend[ nRead ] );

				nRes = ::WSASendTo( wsaSock, &wsaBuf, 1, &dwBytes, dwFlags, reinterpret_cast<SOCKADDR*>( &sa_out ), nAddrSize, &wsaOver, NULL );
				if( nRes != SOCKET_ERROR )
				{
					::sprintf_s( cBuf, pUDP->m_nBufSize, "NET::SOCK SEND : %s", reinterpret_cast<CHAR*>( pUDP->m_bySend[ nRead ] ) );
					pUDP->m_pLog->SetLog( cBuf );

					pUDP->m_nSendRead++;

					// Oobt@p̃JE^NA
					if( ( pUDP->m_nSendRead > pUDP->m_nBufAry ) && ( pUDP->m_nSendWrite > pUDP->m_nBufAry ) )
					{
						pUDP->m_nSendRead -= pUDP->m_nBufAry;
						pUDP->m_nSendWrite -= pUDP->m_nBufAry;
					}
				}
			}
		}

		// f[^̎M
		if( wsaEvents.lNetworkEvents & FD_READ )
		{
			int nWrite = pUDP->m_nRecvWrite % pUDP->m_nBufAry;

			// Mf[^擾
			wsaBuf.buf = reinterpret_cast<CHAR*>( &pUDP->m_byRecv[ nWrite ][ nRecvCnt ] );
			::memset( wsaBuf.buf, 0, pUDP->m_nBufSize - nRecvCnt );

			nRes = ::WSARecvFrom( wsaSock, &wsaBuf, 1, &dwBytes, &dwFlags, reinterpret_cast<SOCKADDR*>( &sa_out ), &nAddrSize, &wsaOver, NULL );
			if( nRes != SOCKET_ERROR )
			{
				// MTCY
				if( nRecvCnt + static_cast<int>( dwBytes ) < pUDP->m_nBufSize )
					nRecvCnt += dwBytes;
				else
				{
					::sprintf_s( cBuf, pUDP->m_nBufSize, "NET::SOCK RECV : %s", reinterpret_cast<CHAR*>( pUDP->m_byRecv[ nWrite ] ) );
					pUDP->m_pLog->SetLog( cBuf );

					nRecvCnt = 0;
					pUDP->m_nRecvWrite++;

					// Oobt@p̃JE^NA
					if( ( pUDP->m_nRecvRead > pUDP->m_nBufAry ) && ( pUDP->m_nRecvWrite > pUDP->m_nBufAry ) )
					{
						pUDP->m_nRecvRead -= pUDP->m_nBufAry;
						pUDP->m_nRecvWrite -= pUDP->m_nBufAry;
					}
				}
			}
		}

		// \Pbg̐ؒf
		if( wsaEvents.lNetworkEvents & FD_CLOSE )
			break;

		// ҋ@
		::Sleep( 1 );
		::WSAResetEvent( wsaOver.hEvent );
	}

ERROR_THREAD:
	::shutdown( wsaSock, SD_BOTH );
	if( wsaOver.hEvent != NULL )
		::WSACloseEvent( wsaOver.hEvent );
	::closesocket( wsaSock );
	wsaSock = -1;
	pUDP->m_bConnect = FALSE;

	::sprintf_s( cBuf, pUDP->m_nBufSize, "NET::SOCK %s:%d UDP/IP MI", pUDP->m_sAddr.c_str(), pUDP->m_nPort );
	pUDP->m_pLog->SetLog( cBuf );

	delete[] cBuf;

	::_endthreadex( 0 );
	return TRUE;
}

/*******************************************************************************
 *	@fn				CSock::CSock( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CSock::CSock( void )
	: m_pLog( NULL )
	
	, m_pSock( -1 )
	, m_nBufSize( 0 )
	, m_nBufAry( 0 )
	, m_bConnect( FALSE )

	, m_sAddr()
	, m_nPort( 0 )
	, m_nSock( -1 )

	, m_byRecv( NULL )
	, m_nRecvRead( 0 )
	, m_nRecvWrite( 0 )
	, m_bySend( NULL )
	, m_nSendRead( 0 )
	, m_nSendWrite( 0 )
{
}

/*******************************************************************************
 *	@fn				CSock::~CSock( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CSock::~CSock( void )
{
	// Mobt@
	for( int i = 0; i < m_nBufAry; i++ )
		delete[] m_bySend[ i ];
	delete[] m_bySend;

	// Mobt@
	for( int i = 0; i < m_nBufAry; i++ )
		delete[] m_byRecv[ i ];
	delete[] m_byRecv;
}

/*******************************************************************************
 *	@fn				int CSock::Init( CLog *pLog,
 *									 const int& nBufSize,
 *									 const int& nBufAry )
 *	@param[in]		pLog						OǗNX
 *	@param[in]		nBufSize					TCP/IPMTCY
 *	@param[in]		nBufAry						m_nBufSize z
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CSock::Init( CLog *pLog,
				 const int& nBufSize,
				 const int& nBufAry )
{
	m_pLog = pLog;
	m_nBufSize = nBufSize;
	m_nBufAry = nBufAry;

	// Mobt@쐬
	m_byRecv = new BYTE*[ m_nBufAry ];
	for( int i = 0; i < m_nBufAry; i++ )
		m_byRecv[ i ] = new BYTE[ m_nBufSize ];

	// Mobt@쐬
	m_bySend = new BYTE*[ m_nBufAry ];
	for( int i = 0; i < m_nBufAry; i++ )
		m_bySend[ i ] = new BYTE[ m_nBufSize ];

	return TRUE;
}

/*******************************************************************************
 *	@fn				void CSock::End( void )
 *	@retval			none						Ȃ
 *	@brief			I
 ******************************************************************************/
void CSock::End( void )
{
	Disconnect();
}

/*******************************************************************************
 *	@fn				void CSock::Connect( const SOCKET* pSock,
 *										 const std::string& pAddr,
 *										 const int& nPort,
 *										 const int& nSock )
 *	@param[in]		pSock						ڑ\Pbg
 *	@param[in]		sAddr						ڑIPAhX
 *	@param[in]		nPort						ڑ|[gԍ
 *	@param[in]		nSock						ڑ@
 *	@retval			none						Ȃ
 *	@brief			ڑ
 ******************************************************************************/
void CSock::Connect( const SOCKET* pSock,
					 const std::string& sAddr,
					 const int& nPort,
					 const int& nSock )
{
	m_pSock = *pSock;
	m_sAddr = sAddr;
	m_nPort = nPort;
	m_nSock = nSock;

	// 
	m_bConnect = TRUE;

	m_nRecvRead = 0;
	m_nRecvWrite = 0;
	m_nSendRead = 0;
	m_nSendWrite = 0;

	unsigned int uiID;
	HANDLE hID;
	// TCP/IPMpXbhN
	if( m_nSock == SOCK_TCP )
	{
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CSock::StreamThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}else
	if( m_nSock == SOCK_UDP )
	// UDP/IPMpXbhN
	{
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CSock::DGramThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}
}

/*******************************************************************************
 *	@fn				void CSock::Disconnect( void )
 *	@retval			none						Ȃ
 *	@brief			ؒf
 ******************************************************************************/
void CSock::Disconnect( void )
{
	m_bConnect = FALSE;
}

/*******************************************************************************
 *	@fn				void CSock::SetPacket( const BYTE* byData )
 *	@param[in]		byData						Mf[^
 *	@retval			none						Ȃ
 *	@brief			Mf[^
 ******************************************************************************/
void CSock::SetPacket( const BYTE* byData )
{
	int nWrite = m_nSendWrite % m_nBufAry;
	::memcpy_s( m_bySend[ nWrite ], m_nBufSize, byData, m_nBufSize );
	m_nSendWrite++;
}

/*******************************************************************************
 *	@fn				void CSock::GetPacket( const BYTE* byData )
 *	@param[in]		byData						Mf[^
 *	@retval			none						Ȃ
 *	@brief			Mf[^
 ******************************************************************************/
void CSock::GetPacket( const BYTE* byData )
{
	int nWrite = m_nRecvWrite % m_nBufAry;
	::memcpy_s( m_byRecv[ nWrite ], m_nBufSize, byData, m_nBufSize );
	m_nRecvWrite++;
}

/*******************************************************************************
 *	@fn				const BYTE* CSock::SetPacket( void )
 *	@retval			BYTE*						Mf[^
 *	@brief			Mf[^
 ******************************************************************************/
const BYTE* CSock::SetPacket( void )
{
	if( m_nSendRead < m_nSendWrite )
	{
		int nRead = m_nSendRead % m_nBufAry;
		m_nSendRead++;
		return ( m_bySend[ nRead ] );
	}
	return NULL;
}

/*******************************************************************************
 *	@fn				const BYTE* CSock::GetPacket( void )
 *	@retval			BYTE*						Mf[^
 *	@brief			Mf[^
 ******************************************************************************/
const BYTE* CSock::GetPacket( void )
{
	if( m_nRecvRead < m_nRecvWrite )
	{
		int nRead = m_nRecvRead % m_nBufAry;
		m_nRecvRead++;
		return ( m_byRecv[ nRead ] );
	}
	return NULL;
}

}	// namespace	NET
