/*******************************************************************************
 *	@file			Sock.h
 *	@brief			Network Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			10-Jan-2012(Tue)
 ******************************************************************************/

#ifndef	__SOCK_INCLUDE__
#define	__SOCK_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "Net.h"
#include "Log.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	NET
 ******************************************************************************/
namespace	NET
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CSock			Sock.h				"Sock.h"
 *	@brief		CSockNX
 ******************************************************************************/
class CSock
{
// 萔`---------------------------------------------------------------------
private:
protected:
public:
	static const int	TIMEWAIT_TCP	= 20;									//!< 20ms҂
	static const int	TIMEWAIT_UDP	= 10;									//!< 10ms҂
	static const int	SOCK_TCP		= 0;
	static const int	SOCK_UDP		= 1;
	static const int	SOCK_DUMMY		= 2;

// o֐-------------------------------------------------------------------
private:
	static unsigned __stdcall StreamThread( void *p );							//!< TCP/IPMpXbh
	static unsigned __stdcall DGramThread( void *p );							//!< UDP/IPMpXbh

protected:
public:
	CSock( void );
	~CSock( void );

	int Init( CLog *pLog,
			  const int& nBufSize,
			  const int& nBufAry );												//!< 
	void End( void );															//!< I

	const BOOL GetUsed( void ){ return ( m_pSock == -1 ? FALSE : TRUE ); }		//!< gptO擾
	const char* GetIPAddr( void ){ return m_sAddr.c_str(); }					//!< IPAhX擾
	const int GetPort( void ){ return m_nPort; }								//!< |[gԍ擾

	void Connect( const SOCKET *pSock,
				  const std::string& sAddr,
				  const int& nPort,
				  const int& nSock );											//!< ڑ
	void Disconnect( void );													//!< ؒf

	void SetPacket( const BYTE* byData );										//!< Mf[^
	void GetPacket( const BYTE* byData );										//!< Mf[^

	const BYTE* SetPacket( void );												//!< Mf[^
	const BYTE* GetPacket( void );												//!< Mf[^

// oϐ-------------------------------------------------------------------
private:
	CLog					*m_pLog;											//!< OǗNX

	SOCKET					m_pSock;											//!< \Pbg
	int						m_nBufSize;											//!< MTCY
	int						m_nBufAry;											//!< m_nBufSize z
	BOOL					m_bConnect;											//!< ڑtO

	std::string				m_sAddr;											//!< IPAhX
	int						m_nPort;											//!< |[gԍ
	int						m_nSock;											//!< ڑ@

	// Mobt@
	BYTE					**m_byRecv;											//!< Mobt@
	int						m_nRecvRead;
	int						m_nRecvWrite;

	BYTE					**m_bySend;											//!< Mobt@
	int						m_nSendRead;
	int						m_nSendWrite;

protected:
public:

};

// OO[oϐ-----------------------------------------------------------

// O֐vg^Cv錾-----------------------------------------------------

}	// namespace	NET

#ifdef __cplusplus
}
#endif

#endif	// __SOCK_INCLUDE__
