/*******************************************************************************
 *	@file			UDP.h
 *	@brief			Network Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			26-Jan-2012(Thu)
 ******************************************************************************/

#ifndef	__UDP_INCLUDE__
#define	__UDP_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "Net.h"
#include "Log.h"
#include "Sock.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	NET
 ******************************************************************************/
namespace	NET
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CUDP			UDP.h				"UDP.h"
 *	@brief		CUDPNX
 ******************************************************************************/
class CUDP
{
// 萔`---------------------------------------------------------------------
private:
	static const int	SENDRETRY		= 8;									//!< đM
protected:
public:

// o֐-------------------------------------------------------------------
private:
	static unsigned __stdcall UnicastThread( void *p );							//!< jLXgpXbh
	static unsigned __stdcall ConnectThread( void *p );							//!< ڑpXbh

	void Connect( const SOCKET* sock,
				  const SOCKADDR_IN& out,
				  const int nSock = CSock::SOCK_UDP );							//!< \Pbgڑ

protected:
public:
	CUDP( void );
	~CUDP( void );

	void Startup( const SNET& SUdp );											//!< JnO\̐ݒ

	int Init( CLog *pLog,
			  const char* hostname,
			  const char* ip );													//!< 
	int End( void );															//!< I

	const char* GetIPAddr( const int n );										//!< IPAhX擾
	const int GetPort( const int n );											//!< |[gԍ擾
	int P2PConnect( const char* cAddr,
					const char* cPort );										//!< P2Pڑ

	void Send( BYTE* byData );													//!< f[^̑M
	const BYTE* Recv( void );													//!< f[^̎M

// oϐ-------------------------------------------------------------------
private:
	SNET					m_SUdp;												//!< UDP/IP\

	CLog					*m_pLog;											//!< OǗNX
	CSock					*m_pSock;											//!< \PbgǗNX

	// 
	char					m_cHostName[ MAXGETHOSTSTRUCT + 1 ];				//!< zXg
	char					m_cIPAddr[ 32 ];									//!< IPAhX

	BOOL					m_bConnect;											//!< ڑtO
	int						m_nRecvTmp;											//!< Mp̃JE^[

protected:
public:

};

// OO[oϐ-----------------------------------------------------------

// O֐vg^Cv錾-----------------------------------------------------

}	// namespace	NET

#ifdef __cplusplus
}
#endif

#endif	// __UDP_INCLUDE__
